#include <stdio.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <math.h>
#include <grace_np.h>
#include <unistd.h>
#include <float.h>
#include <limits.h>
#include <signal.h>
#include <cash2003.h>
#include <cash2.h>
#include <mersenne.h>
#include <cash2-s.h>

/* types of cell */
const int EMPTY = 0;
const int X = 1;
const int Y = 2;
const int Z = 3;

/* parameters */
double X2Y =0.7;
double Y2X =0.7;
double Y2Z =1.0;
double NON = 0.3;
double DEATH = 0.3;

static TYPE2** Cheater;
static TYPE2** ST; // space-time plot

double sumx,sumy,sumz,px,py,pz,pz2,psum,ran;


void Initial(void)
{
  MaxTime = 2147483647; /* default=2147483647 */
  nrow = 250; /* # of row (default=100)*/
  ncol = 250; /* # of column (default=100)*/
  nplane = 2; /* # of planes (default=0)*/
  scale = 2; /* size of the window (default=2)*/
  boundary = WRAP; /* the type of boundary: FIXED, WRAP, ECHO (default=WRAP). Note that
		      Margolus diffusion is not supported for ECHO. */
  ulseedG = 56; /* random seed (default=56)*/

  /* useally, one does not have to change the followings */
  /* the value of boundary (default=(TYPE2){0,0,0,0,0,0.,0.,0.,0.,0.})*/
  boundaryvalue2 = (TYPE2){0,0,0,0,0,0.,0.,0.,0.,0.};
}


void InitialPlane(void)
{
  MakePlane(&Cheater,&ST);

	/*char* readOut;
	/for(int i = 0; i < (int)argc_g; i++)
	{
	    readOut = (char*)argv_g[i];
	    if(strcmp(readOut, "-mut1") == 0) X2Y = atof(argv_g[i+1]);
	    if(strcmp(readOut, "-mut2") == 0) Y2X = atof(argv_g[i+1]);
	    if(strcmp(readOut, "-cheat1") == 0) Y2Z = atof(argv_g[i+1]);
	    if(strcmp(readOut, "?") == 0) Y2Z = atof(argv_g[i+1]);
	}

  printf("\n-= Now running cheater.c =-\n\nParameters used: \nMutualist 1:\t%f (white)\nMutualist 2:\t%f (red)\nCheater1:\t%f (blue)\n\n", X2Y, Y2X, Y2Z);
  */

  // Setting some user-defined colours -- changing green to blue for colorblind people
  ColorRGB(0,0,0,0);
  ColorRGB(1,255,0,0);
  ColorRGB(2,255,255,255);
  ColorRGB(3,0,0,155);
  ColorRGB(4,0,255,0);

  // InitialSet(1,2,3,4,5) with 1) plane name, 2) number of non-empty states, 3) background state (0), 4) state to set 5) fraction that gets state from 4, 6) state to set, 7) fraction of state 6, etc.
  InitialSet(Cheater,3,EMPTY,X,0.1,Y,0.1,Z,0.1);
  Boundaries2(Cheater);
}


void NextState(int row,int col)
{

if (Cheater[row][col].val==0){
  int sumx= CountMoore8(Cheater,X,row,col);
  int sumy= CountMoore8(Cheater,Y,row,col);
  int sumz= CountMoore8(Cheater,Z,row,col);


	px= (Y2X* sumy)*sumx;
	py= (X2Y* sumx)*sumy;
	pz= (Y2Z* sumy)*sumz;
	psum=px+py+pz+NON;
	ran=genrand_real1();

  if (ran < px/psum){
    Cheater[row][col].val = X;
  }else if (ran < (px+py)/psum){
    Cheater[row][col].val = Y;
  }else if (ran < (px+py+pz)/psum){
    Cheater[row][col].val = Z;
  }
}
else{
 if (genrand_real1()<DEATH){
   Cheater[row][col].val=EMPTY;
 }
}

}

void Update(void)
{
  //Plot(1,Cheater);

  SpaceTimePlot(ST,Cheater);
  Display(Cheater,ST);
  Synchronous(1,Cheater);
  if (Time%10==0){
     MDiffusion(Cheater);
  }
  //PerfectMix(Cheater);
}
